e<!DOCTYPE html>
<html lang="zxx">

<head>
  <meta charset="utf-8">
  <title>Thomson-Minimal Portfolio</title>

  <!-- mobile responsive meta -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

  <!-- ** Plugins Needed for the Project ** -->
  <!-- Bootstrap -->
  <link rel="stylesheet" href="plugins/bootstrap/bootstrap.min.css">
  <link rel="stylesheet" href="plugins/themify/css/themify-icons.css">
  <link rel="stylesheet" href="plugins/counto/animate.css">
  <link rel="stylesheet" href="plugins/aos/aos.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.carousel.min.css">
  <link rel="stylesheet" href="plugins/owl-carousel/owl.theme.default.min.css">
  <link rel="stylesheet" href="plugins/magnific-popup/magnific-popup.css">
  <link rel="stylesheet" href="plugins/animated-text/animated-text.css">

  <!-- Main Stylesheet -->
  <link href="css/style.css" rel="stylesheet">

</head>

<body>
  <style>
  body {
      background-color: ##efefef;

  }
  </style>
<!-- Header Start -->

<nav class="navbar navbar-expand-lg  main-nav " id="navbar">
	<div class="container">
	  <a class="navbar-brand" href="simpletemplate/index.html">

      <div align="center">
        <img src="images/logonaty.png" style= "width: 50px" align="center" >

      </div>
	  </a>

	  <button class="navbar-toggler collapsed" type="button" data-toggle="collapse" data-target="#navbarsExample09" aria-controls="navbarsExample09" aria-expanded="false" aria-label="Toggle navigation">
		<span class="ti-align-justify"></span>
	  </button>

		  <div class="collapse navbar-collapse" id="navbarsExample09">
			<ul class="navbar-nav ml-auto">
         <li class="nav-item  active"><a class="nav-link" href="introductiontodigitalfabrication.html">Return</a></li>
			  <li class="nav-item  active"><a class="nav-link" href="index.html">Main Page</a></li>

         <li class="nav-item  active"><a class="nav-link" href="about.html">About Me</a></li>



			   <li class="nav-item"><a class="nav-link" href="https://gitlab.com/flu">Gitlab Repo</a></li>
			</ul>
		</div>
	</div>
</nav>





<!-- Header Close -->




  <div class="container">
<!-- <div class="col-12"> -->

      <!-- </div> -->



<div class="col-lg-12 col-xs-12">
<section class="section blog-post" style="padding: 100px 180px;">
	<div class="container">
		<div class="row">
			<!-- <div class="col-lg-6"> -->
				<article class="single-post">
          <div class= "middle" align="justify">
            <h9> Input Devices </h9>

            <h8> 19.4.2020</h8>
            <p> For this week in Fabacademy I decided to use ultrasonic (distance) sensor, as this was anyway the only sensor that my kit contained and also I had previous experience with using it. </p>
            <p> First, I had to connect the sensor to the arduino properly. I had an idea of how to connect it as this sensor does not have many pins, however I wanted to be sure therefore I googled the connection to check if I have done it correctly. Below you can see the connection for distance sensor. </p>

              <img src="images/connection.jpeg" style= "width: 700px" align="center">
              <img src="images/distance.jpg" style= "width: 700px" align="center">

              <p> After having the sensor connected, I needed to install the library for this sensor. At first I installed ultrasonic library, however the code did not work that well therefore I have found library and example code for HCSR04 that worked perfectly. <a href="https://randomnerdtutorials.com/complete-guide-for-ultrasonic-sensor-hc-sr04/website">This website</a> explains the sensor it detail, which helped me understand how it works better. </p>
              <img src="images/kniznica.jpg" style= "width: 700px" align="center">

              <p> To make the sensor work, I had to include the library in the code and choose correct pins for Trig and Echo. I have uploaded the code shown below into the board and opened serial monitor to see the how the sensor reads values. The values (in cm) were read well, even though sometimes there were random high values showing, after quick movement in front of the sensor. I knew this might cause issues in next development and making something react to sensor values, however for now I ignored it. </p>
              <img src="images/reading.jpg" style= "width: 700px" align="center">
              <video width="700" height="320" controls>
                <source src="images/reading.mp4" type="video/mp4">

              </video>
              <a href="images/distance3.zip" download>FILE HERE</a>
<p></p>
  <p> Having the sensor properly connected, I have tried to make the led fade according to values in distance sensor. I tried to code this on my own however, I could not make it work. Turning Led on and off according to distance with if condition worked fine, however with fading I was struggling. Therefore I decided to help myself with <a href="https://easyarduino.webs.com/ultrasonicfadeled.htm">this tutorial</a> and I realised that what I was missing was MAP function. I am glad I did this excercise becuase it made me understand how the map function works and how important and widely used it is. </p>
  <p> The closer I am to sensor, the lower the leds shine. </p>
  <img src="images/fadingg.jpg" style= "width: 700px" align="center">

  <video width="700" height="320" controls>
    <source src="images/fading.mp4" type="video/mp4">
  </video>

  <a href="images/finalfading.zip" download>FILE HERE</a>

<p> Seeing the sensor working fine, I have decided to be brave and experiment with connecting Arduino to Processing and make the values from sensor influence the drawing I have previously drawn in Processing. This typographic drawing of letter G was coded to change the strokeWeight according to orientation of the mouse. </p>
<video width="700" height="320" controls>
  <source src="images/g.mp4" type="video/mp4">
</video>

<p> To connect arduino to processing I have researched various tutorials with very similar codes, however eventually I followed <a href="https://electronicshobbyists.com/arduino-processing-tutorial-connect-arduino-to-processing/">this tutorial.</a> In processing I had to import serial and l declare a variable of type serial. After that, I had to set the port and the baud rate. The biggest issue I had was setting the port in processing for the two software to communicate between each other, take readings from serial port and work with them in Processing. In Windows port is usually COM3, however I had to open terminal and use command ls /dev/*. to find the name of port on my computer. </p>
<p> Terminal showed me two results, one starting with tty and the other cu, I tried both and found out that the tty did not work, cu was succesful. </p>
<img src="images/port.jpg" style= "width: 700px" align="center">
<p> To set the value read from arduino to processing, I had to include not only void setup and void draw but also void serial event and store the value into float :   value = float(get.readStringUntil('\n')); , this value I inserted into draw loop into various places for different results (strokeweight, background etc..) </p>
<p> As expected, I have had a problem with flawed high reading from arduino that cause the changes in drawing to buffer. I had tried to calibrate it in various ways (to set the treshold for reading, ignoring the high values in serial monitor, as well as decreasing the value by dividing it by distance/100), however what worked the best for calibration so far was to set the delay quite low -- to delay(5) and to map the value and set the maximum to 50 (which was the highest value for optimal reading in serial monitor. ) </p>
<p> code </p>
<img src="images/code.jpg" style= "width: 700px" align="center">
<a href="images/processing.zip" download>ARDUINO</a>
<a href="images/sketcharduino.zip" download>PROCESSING</a>


<p> initial buffering </p>
<video width="700" height="320" controls>
  <source src="images/reading_1.mp4" type="video/mp4">
</video>
<p> Improved versions </p>

<video width="700" height="320" controls>
  <source src="images/improved.mp4" type="video/mp4">
</video>

<video width="700" height="320" controls>
  <source src="images/strokec.mp4" type="video/mp4">
</video>
<video width="700" height="320" controls>
  <source src="images/strokeb.mp4" type="video/mp4">
</video>
<video width="700" height="320" controls>
  <source src="images/strokea.mp4" type="video/mp4">
</video>

<p> This for me, has been the most fun assignment so far, I would definetely love to keep experimenting and exploring with Processing and finding different ways for Arduino and Processing to communicate. I would also like to explore communication between Arduino and Grasshopper. I have been falling in love with generative design and feel that my imagination has been expanded. </p>






		<!-- <div class="post-meta mb-4">

		</div> -->
		<div class="share mt-4">
			<ul class="list-inline">
				<li class="mb-3">Share Now :</li>
				<li class="list-inline-item"><a href="#"><i class="ti-facebook mr-2"></i> Facebook</a></li>
				<li class="list-inline-item"><a href="#"><i class="ti-twitter mr-2"></i> Twitter</a></li>
				<li class="list-inline-item"><a href="#"><i class="ti-linkedin mr-2"></i> Linkedin</a></li>
				<li class="list-inline-item"><a href="#"><i class="ti-pinterest mr-2"></i> Pinterest</a></li>
			</ul>
		</div>
	</div>
  </article>


</div>
			</div>
		</div>
	</div>
</section>

<section class="footer">
	<div class="container">
		<div class="row ">
			<div class="col-lg-6">
				<p class="mb-0">Copyrights © 2019. Designed & Developed by <a href="themefisher.com" class="text-white">Themefisher</a></p>
			</div>
			<div class="col-lg-6">
				<div class="widget footer-widget text-lg-right mt-5 mt-lg-0">
					<ul class="list-inline mb-0">
						<li class="list-inline-item"><a href="https://www.facebook.com/themefisher" target="_blank"><i class="ti-facebook mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://twitter.com/themefisher" target="_blank"><i class="ti-twitter mr-3"></i></a>
						</li>
						<li class="list-inline-item"><a href="https://github.com/themefisher/" target="_blank"><i class="ti-github mr-3"></i></a></li>
						<li class="list-inline-item"><a href="https://www.pinterest.com/themefisher/" target="_blank"><i class="ti-pinterest mr-3"></i></a></li>
						<li class="list-inline-item"><a href="https://dribbble.com/themefisher/" target="_blank"><i class="ti-dribbble mr-3"></i></a></li>
					</ul>
				</div>
			</div>
		</div>
	</div>
</section>
<!-- jQuery -->
<script src="plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="plugins/bootstrap/bootstrap.min.js"></script>
<script src="plugins/aos/aos.js"></script>
<script src="plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="plugins/shuffle/shuffle.min.js"></script>
<script src="plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="plugins/animated-text/animated-text.js"></script>
<script src="plugins/counto/apear.js"></script>
<script src="plugins/counto/counTo.js"></script>

 <!-- Google Map -->
<script src="plugins/google-map/map.js"></script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAkeLMlsiwzp6b3Gnaxd86lvakimwGA6UA&callback=initMap"></script>
<!-- Main Script -->
<script src="js/script.js"></script>

</html>
